function love.load()
	require 'luafft'
	
	love.graphics.setCaption('loveEQ')
	sound = love.sound.newSoundData('yes.ogg')
	rate = sound:getSampleRate()
	print(rate)
	
	music = love.audio.newSource(sound)
	music:play()
	
	spectrum = {}
	gTime = 0
	
	love.graphics.setLine(1,'smooth')
end

function love.update(dt)
	gTime = gTime+dt
	
	local curSample = math.floor(rate*gTime)
	local wave = {}
	local size = next_possible_size(512)
	for i=curSample, curSample+(size-1) do
		table.insert(wave,complex.new(sound:getSample(i),0))
	end
	
	local spec = fft(wave,false)
	local reconstructed = fft(spec,true)
	
	
	function divide(list, factor)
		for i,v in ipairs(list) do
			list[i] = list[i] / factor
		end
	end
	
	divide(reconstructed,size)
	divide(spec,size/2)
	
	spectrum = spec
end

function love.draw()
	local division = 10
	for i=1, #spectrum/division do
		local height = love.graphics.getHeight()
		local width = love.graphics.getWidth()
		local dist = width / (#spectrum/division)
		
		local v = spectrum[i]
		local n = v:abs(),1
		love.graphics.rectangle(
			'fill',
			(i-1)*dist,height/2 - n*100,
			10,n*200
		)
		
--		love.graphics.print(n,0,i*12)
	end
end

function limit_max(v,limit)
	if v > limit then
		return limit
	end
	return v
end

function limit_min(v,limit)
	if v < limit then
		return limit
	end
	return v
end